Subject: bug#18984: Antw: Re: bug#18984: Enhancement request: Handling of damaged partition tables

From: "Ulrich Windl" <[email-masked]>
Date: Tue, 11 Nov 2014 08:54:36 +0100

>>> Phillip Susi <[email-masked]> schrieb am 10.11.2014 um 19:15 in Nachricht
<[email-masked]>:
[...]
>> 1) Instead of saying "Can't have a partition outside the disk!"
>> say _which_ partition you think is outside the disk, and say _why_
>> you think so.
> 
> I suppose that could be nice, though when you print the table and have
> a look for yourself it isn't hard to figure out.  In your case your
> "disk" is only one sector long so everything is outside of that.

Actually a computer can compare and intersect numeric intervals much faster than I can. Of course up to now we all can do what computers can do, but are we to relieve the computers, or is it the other way 'round?

> 
>> 2) Despite of the message "Invalid partition table on
>> /home/wiu09524/Projekte/sect0.0 -- wrong signature 0." the MBR 
>> signature is 0x55, 0xaa as expected
> 
> It is talking about the extended partition table which it sees as all
> zeroes since you don't have it in the image file, the read failed, and
> you chose to ignore that failure.

That's not obvious from the message. What about "Invalid partition table at sector ### of <device> -- wrong signature..."?

> 
>> 3) Instead of saying "Can't have overlapping partitions." say
>> _which_ partitions you think overlap with which other partitions,
>> and perferrably give precise data for the overlap. Parted should
>> not just help secretaries, but technicals also ;-)
> 
> Same as above: might be nice but it's pretty easy to figure out by
> looking at the output of print.

See above, too.

[...]
>> Finally everything converted to LBAs and then to GB (1024^2 kB): 
>> partition #1:    7.875    7.875  796.011  100.007 (   0.000 /
>> -696.004) partition #2:    7.871    7.875  296.009  635.491 (
>> 0.004 /  339.482) partition #3:    7.875    7.875   96.009  200.000
>> (   0.000 /  103.991) partition #4:    0.001    7.875    0.001
>> 96.008 (   7.874 /   96.007)
>> 
>> You see that partition #1 (the last entry in the table) features a 
>> negative size!
> 
> There is no such thing as a negative size since the table lists the
> start and length ( not end ) as unsigned dwords.

OK, my fault (I remembered it incorrectly)!

> 
>> It would be great if parted could not only complain, but also
>> suggest how to fix the problems detected, just like fsck does for
>> years.
> 
> The fix should be obvious: delete one of the overlapping partitions,
> or shrink the first one.  How to do that safely is too involved to
> suggest in a short error message.